// ANNA - Anna is Not Nothingness Anymore                                                         //
//                                                                                                //
// (c) Copyright 2005-2015 Eduardo Ramos Testillano & Francisco Ruiz Rayo                         //
//                                                                                                //
// See project site at http://redmine.teslayout.com/projects/anna-suite                           //
// See accompanying file LICENSE or copy at http://www.teslayout.com/projects/public/anna.LICENSE //


#include <iostream>

#include <anna/core/core.hpp>

#include <anna/xml/Node.hpp>
#include <anna/xml/Parser.hpp>
#include <anna/xml/DocumentFile.hpp>
#include <anna/xml/functions.hpp>

#include <anna/app/Application.hpp>

#include <anna/core/util/Encoder.hpp>

class Test : public app::Application {
public:
   Test ();
   
   void initialize () throw (RuntimeException);
   
private:
   void  run () throw (RuntimeException);      
};

using namespace std;

int main (int argc, const char** argv)
{
   CommandLine& commandLine (CommandLine::instantiate ());
   Test test;

   try {
      commandLine.initialize (argv, argc);
      commandLine.verify ();

      test.start ();
   }
   catch (Exception& ex) {
      cout << ex.asString () << endl;
   }
   
   return 0;
}

Test::Test () : 
   app::Application ("GenerateLogOn", "Database login keys visualizer", "1.0.0")
{
   CommandLine& commandLine (CommandLine::instantiate ());
      
   commandLine.add ("logon", CommandLine::Argument::Mandatory, "XML document with user/password encrypted");
}

void Test::initialize () 
   throw (RuntimeException)
{
   Encoder::initialize ();   
   xml::functions::initialize ();
}

void Test::run () 
   throw (RuntimeException)
{
   CommandLine& commandLine (CommandLine::instantiate ());

   xml::DocumentFile xmlDocument;
   xml::Parser xmlParser;
   Encoder encoder;
   EncodedData edata;  
   
   xmlDocument.initialize (commandLine.getValue ("logon"));
      
   const xml::Node* root = xmlParser.apply (xmlDocument);
   
   edata.initialize (root->find ("User"));   
   const DataBlock& user = encoder.decode (edata);   
   cout << "User: " << user.getData () << endl;
   
   edata.initialize (root->find ("Password"));
   const DataBlock& password = encoder.decode (edata);   
   cout << "Password: " << password.getData () << endl << endl;
}

