// ANNA - Anna is Not Nothingness Anymore                                                         //
//                                                                                                //
// (c) Copyright 2005-2015 Eduardo Ramos Testillano & Francisco Ruiz Rayo                         //
//                                                                                                //
// See project site at http://redmine.teslayout.com/projects/anna-suite                           //
// See accompanying file LICENSE or copy at http://www.teslayout.com/projects/public/anna.LICENSE //


#ifndef example_diameter_launcher_MyDiameterEntity_hpp
#define example_diameter_launcher_MyDiameterEntity_hpp

// Project
#include <anna/diameter.comm/Entity.hpp>
#include <anna/diameter/codec/MessagesDeque.hpp>


namespace anna {
  namespace diameter {
    namespace codec {
      class Engine;
    }
  }
}

class MyDiameterEntity : public anna::diameter::comm::Entity {

  void eventRequestRetransmission(const anna::diameter::comm::ClientSession *, anna::diameter::comm::Message*) throw();
  void eventResponse(const anna::diameter::comm::Response&) throw(anna::RuntimeException);
  void eventRequest(anna::diameter::comm::ClientSession *, const anna::DataBlock&) throw(anna::RuntimeException);
  void eventUnknownResponse(anna::diameter::comm::ClientSession *, const anna::DataBlock&) throw(anna::RuntimeException);
  void eventDPA(anna::diameter::comm::ClientSession *, const anna::DataBlock&) throw(anna::RuntimeException);

public:

  MyDiameterEntity() {;}
  virtual ~MyDiameterEntity() {;}

  anna::diameter::codec::MessagesDeque a_reactingAnswers;
  anna::diameter::codec::MessagesDeque *getReactingAnswers() throw() { return (anna::diameter::codec::MessagesDeque*)&a_reactingAnswers; }
};

#endif
