#!/bin/bash

# Generates SMS burst sequence for provided order number (1: first, 2: second, etc.)
SEQN=$1

salir () {
   echo
   echo $1
   echo
   exit
}

[[ "$SEQN" = "" ]] && salir "Use: $0 <sequence number: 1..N>"
[[ ! -f sms.msk ]] && salir "Template file (sms.msk) not found!"

# Sequence values at template sms.msk:
# __HBH_ETE__: 1, 3, 5, etc. (hop-by-hop and end-to-end)
# __SID_LOW__: 1000, 1001, 1002, etc. (Session-Id sequence append)
# __MSISDN__:  5555100000, 5555100001, 5555100002, etc. (First and Third Address-Data)
# __IMSI__:    262075555100000, 262075555100001, 262075555100002, etc. (Second Address-Data)

OFFSET=$((SEQN-1))

HBH_ETE=$((1 + 2*OFFSET))
SID_LOW=$((1000+OFFSET))
MSISDN=$((5555100000+OFFSET))
IMSI=$((262075555100000+OFFSET))

cat sms.msk | sed 's/__HBH_ETE__/'$HBH_ETE'/g' | sed 's/__SID_LOW__/'$SID_LOW'/' \
            | sed 's/__MSISDN__/'$MSISDN'/' | sed 's/__IMSI__/'$IMSI'/'
