// ANNA - Anna is Not Nothingness Anymore                                                         //
//                                                                                                //
// (c) Copyright 2005-2015 Eduardo Ramos Testillano & Francisco Ruiz Rayo                         //
//                                                                                                //
// See project site at http://redmine.teslayout.com/projects/anna-suite                           //
// See accompanying file LICENSE or copy at http://www.teslayout.com/projects/public/anna.LICENSE //


#ifndef anna_comm_Resource_hpp
#define anna_comm_Resource_hpp

#include <anna/core/mt/Resource.hpp>

namespace anna {

namespace xml {
class Node;
}

namespace comm {

/**
   Clase que modela un recurso de acceso compartido.
*/
class Resource : public anna::Resource {
public:
  /**
     Devuelve un nodo XML con la informacin referente a este objeto.
     \param parent Nodo XML a partir del cual introducir la informacin.
     \return Un nodo XML con la informacin referente a este objeto.
  */
  virtual xml::Node* asXML(xml::Node* parent) const throw(RuntimeException);

  /**
     Amplia la informacion XML del nodo recibido como parametro.
     \param node Nodo XML en el que incorporar los atributos.
  */
  virtual void asAttribute(xml::Node* node) const throw(RuntimeException);

protected:
  /**
     Constructor.
     \param name Nombre logico de este recurso remoto.
     \param mode Modo de actuacion de esta instancia en modo ST cuando montamos una seccion critca sobre este objeto.
      En modo MT siempre sera Mode::Normal, es decir abre una seccion critica sobre este objeto, que bloqueara a
      cualquier otro thread que intente acceder a el.
  */
  Resource(const std::string& name) :  anna::Resource(name) {;}
};

}
}

#endif
