// ANNA - Anna is Not Nothingness Anymore                                                         //
//                                                                                                //
// (c) Copyright 2005-2015 Eduardo Ramos Testillano & Francisco Ruiz Rayo                         //
//                                                                                                //
// See project site at http://redmine.teslayout.com/projects/anna-suite                           //
// See accompanying file LICENSE or copy at http://www.teslayout.com/projects/public/anna.LICENSE //


#ifndef anna_http_functions_hpp
#define anna_http_functions_hpp

#include <anna/core/RuntimeException.hpp>

namespace anna {

class DataBlock;

namespace http {

/**
   functions - Metodos y variables
*/
struct functions {
  /**
     Inicializa el modulo de analisis de mensajes HTTP, debe ser invocado antes
     usar cualquier clase de este paquete.
  */
  static void initialize() throw();

  /**
     Devuelve la posicion dentro del buffer definido por \em data en la que se
     encuentra la primera ocurrencia de \em str. En caso de no encontrarse la
     cadena devolvera -1.

     \param data Buffer donde buscar la cadena recibida como parametro.
     \param size Longitud del bufffer donde buscar la cadena.
     \param str Cadena teminada en '0' a buscar.

     \return la posicion dentro del buffer definido por \em data en la que se
     encuentra la primera ocurrencia de \em str o \em -1 en caso de no encontrarse la
     cadena.
  */
  static int find(const void* data, const int size, const char* str) throw();
};

}
}

#endif
