// ANNA - Anna is Not Nothingness Anymore                                                         //
//                                                                                                //
// (c) Copyright 2005-2015 Eduardo Ramos Testillano & Francisco Ruiz Rayo                         //
//                                                                                                //
// See project site at http://redmine.teslayout.com/projects/anna-suite                           //
// See accompanying file LICENSE or copy at http://www.teslayout.com/projects/public/anna.LICENSE //


#ifndef anna_http_internal_EncodedBlock_hpp
#define anna_http_internal_EncodedBlock_hpp

#include <anna/core/DataBlock.hpp>

namespace anna {

namespace http {

class EncodedBlock : public DataBlock {
public:
  struct Type { enum _v { None, Chunked }; };
  struct State { enum _v { Completed, Incomplete }; };

  EncodedBlock() : DataBlock(true), a_chunk(true), a_expectedSize(-1), a_type(Type::None) {;}

  Type::_v getType() const throw() { return a_type; }
  bool isValid() const throw() { return a_type != Type::None; }

  void setType(const Type::_v type) throw() { a_type = type; }
  void setExpectedSize(const int expectedSize) throw() { a_expectedSize = expectedSize; }

  void clear() { DataBlock::clear(); a_expectedSize = -1; a_chunk.clear(); a_type = Type::None; }

  State::_v append(const DataBlock& chunk) throw();

private:
  Type::_v a_type;
  DataBlock a_chunk;
  int a_expectedSize;
};

}
}

#endif
