// ANNA - Anna is Not Nothingness Anymore                                                         //
//                                                                                                //
// (c) Copyright 2005-2015 Eduardo Ramos Testillano & Francisco Ruiz Rayo                         //
//                                                                                                //
// See project site at http://redmine.teslayout.com/projects/anna-suite                           //
// See accompanying file LICENSE or copy at http://www.teslayout.com/projects/public/anna.LICENSE //


#ifndef anna_ldap_TimerManager_hpp
#define anna_ldap_TimerManager_hpp

#include <anna/config/defines.hpp>

#include <anna/core/util/Recycler.hpp>
#include <anna/core/Singleton.hpp>

#include <anna/ldap/defines.hpp>
#include <anna/ldap/ClassCode.hpp>
#include <anna/ldap/internal/Timer.hpp>

#include <anna/timex/TimeEventObserver.hpp>

namespace anna {

namespace timex {
class Engine;
}

namespace ldap {

class Response;

/**
   Gestor de temporizadores asociados a las peticiones LDAP.
*/
class TimerManager : public timex::TimeEventObserver, public Singleton <TimerManager> {
  typedef Recycler <Timer> timer_container;

  timer_container a_timers;
  timex::Engine* a_timeController;

  TimerManager();
  TimerManager(const TimerManager&);

  virtual ~TimerManager() {;}

  Timer* createTimer(Response*) throw(RuntimeException);
  void cancel(Timer*) throw();

  void release(timex::TimeEvent*) throw();

  friend class Singleton <TimerManager>;
  friend class Response;
};

}
}

#endif

