// ANNA - Anna is Not Nothingness Anymore                                                         //
//                                                                                                //
// (c) Copyright 2005-2015 Eduardo Ramos Testillano & Francisco Ruiz Rayo                         //
//                                                                                                //
// See project site at http://redmine.teslayout.com/projects/anna-suite                           //
// See accompanying file LICENSE or copy at http://www.teslayout.com/projects/public/anna.LICENSE //


#include <cctype> // for toupper
#include <string>
#include <algorithm>

#include <anna/core/util/String.hpp>
#include <anna/core/functions.hpp>
#include <anna/core//DataBlock.hpp>

using namespace std;
using namespace anna;

void String::toUpper()
throw() {
  std::transform(begin(), end(), begin(), (int(*)(int)) toupper);
}

void String::toLower()
throw() {
  std::transform(begin(), end(), begin(), (int(*)(int)) tolower);
}

String& String::operator<< (const char* vv)
throw() {
  if(vv == NULL) {
    if(a_flags & Flag::ShowNull)
      string::operator+= ("<null>");
  } else
    string::operator+= (vv);

  return *this;
}

String& String::operator<< (const int vv)
throw() {
  char aux [16];
  sprintf(aux, "%d", vv);
  string::operator+= (aux);
  return *this;
}

String& String::operator<< (const unsigned int vv)
throw() {
  char aux [16];
  sprintf(aux, "%u", vv);
  string::operator+= (aux);
  return *this;
}

String& String::operator<< (const S64 vv)
throw() {
  char aux [32];
  //sprintf(aux, "%lld", vv);
  #ifdef __anna64__
    sprintf (aux, "%ld", vv);
  #else
    sprintf (aux, "%lld", vv);
  #endif
  string::operator+= (aux);
  return *this;
}

String& String::operator<< (const U64 vv)
throw() {
  char aux [32];
  //sprintf(aux, "%llu", vv);
  #ifdef __anna64__
    sprintf (aux, "%lu", vv);
  #else
    sprintf (aux, "%llu", vv);
  #endif
  string::operator+= (aux);
  return *this;
}

String& String::operator<< (const float vv)
throw() {
  char aux [64];
  sprintf(aux, "%f", vv);
  string::operator+= (aux);
  return *this;
}

String& String::operator<< (const double vv)
throw() {
  char aux [64];
  sprintf(aux, "%e", vv);
  string::operator+= (aux);
  return *this;
}

String& String::operator<< (const DataBlock& vv)
throw() {
  return *this += vv.asString();
}

//static
String String::format(const DataBlock& vv, const int characterByLine)
throw() {
  return String(vv.asString(characterByLine));
}
